function q4_1
% Q4_1 -- koodi tehtvn Q4.1

n = [1 : 1001];
x = randn(1,1001);
y = zeros(1,1001);

% 5-pisteen "FIR-suodatus"
for k=5:length(x)
  y(k) = 2.37*y(k-1)-2.31*y(k-2)+1.05*y(k-3)-0.19*y(k-4)+x(k);
end;

Enx = sum(x.*x); Eny = sum(y.*y);  % tehot
y   = y*sqrt(Enx/Eny);             % tehojen tasaaminen

xF = fft(x); yF = fft(y);          % FFT
w  = 2*[0 : length(xF)-1]/length(xF);


% Figure No. 1: VALK.KOHINAA
figure(1); clf;
subplot(2,1,1);
plot(n,x); axis([0 1000 -4 4]);
title('0-keskiarvoista gaussista valkoista kohinaa');
xlabel('indeksi (n)');
grid on;

subplot(2,1,2);
plot(w,abs(xF)/max(abs(xF))); axis([0 1 0 1.1]);
title('0-keskiarvoisen gaussisen valkoisen kohinan spektri');
xlabel('kulmataajuus w');
grid on;

% Figure No. 2: VRILLIST KOHINAA
figure(2); clf;
subplot(2,1,1);
plot(n,y); axis([0 1000 -4 4]);
title('Korreloitunutta kohinaa');
xlabel('indeksi (n)');
grid on;

subplot(2,1,2);
plot(w,abs(yF)/max(abs(yF))); axis([0 1 0 1.1]);
title('Korreloituneen kohinan spektri');
xlabel('kulmataajuus w');
grid on;
